From afe3f69b23190f375b57d5cf0a3eae2cd8e40caa Mon Sep 17 00:00:00 2001
From: Boris Mironov <boris.mironov@gmail.com>
Date: Mon, 23 Feb 2026 17:07:16 +0700
Subject: [PATCH v9 23/26] Adding multi-transaction mode to client-side data
 generation

---
 src/bin/pgbench/pgbench.c                    | 52 ++++++++++++--------
 src/bin/pgbench/t/001_pgbench_with_server.pl | 47 +++++++++---------
 2 files changed, 56 insertions(+), 43 deletions(-)

diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index e3e0e073792..1b73da904ad 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -5130,22 +5130,22 @@ showPopulateTableCopyProgress(const char *table, int64 current, int64 total)
 }
 
 static void
-initPopulateTableCopyText(PGconn *con, const char *table, int64 base,
+initPopulateTableCopyText(PGconn *con, const char *table, int counter, int64 base,
 						  initRowMethod init_row)
 {
 	int			n;
-	int64		k;
 	PGresult   *res;
 	PQExpBufferData sql;
 	char		copy_statement[256];
 	const char *copy_statement_fmt = "copy %s from stdin";
-	int64		total = base * scale;
+	int64		start = base * counter;
 
 	initPQExpBuffer(&sql);
 
 	/* Use COPY with FREEZE on v14 and later for all ordinary tables */
 	if ((PQserverVersion(con) >= 140000) &&
-		get_table_relkind(con, table) == RELKIND_RELATION)
+		get_table_relkind(con, table) == RELKIND_RELATION &&
+		!multi_xact)
 		copy_statement_fmt = "copy %s from stdin with (freeze on)";
 
 
@@ -5161,16 +5161,16 @@ initPopulateTableCopyText(PGconn *con, const char *table, int64 base,
 		pg_fatal("unexpected copy in result: %s", PQerrorMessage(con));
 	PQclear(res);
 
-	for (k = 0; k < total; k++)
+	for (int64_t i = start; i < start + base; i++)
 	{
-		init_row(&sql, k);
+		init_row(&sql, i);
 		if (PQputline(con, sql.data))
 			pg_fatal("PQputline failed");
 
 		if (CancelRequested)
 			break;
 
-		showPopulateTableCopyProgress(table, k + 1, total);
+		showPopulateTableCopyProgress(table, i, base * scale);
 	}
 
 
@@ -5193,9 +5193,6 @@ initGenerateDataClientSideTextFrmt(PGconn *con)
 {
 	fprintf(stderr, "TEXT mode...\n");
 
-	if (multi_xact)
-		fprintf(stderr, "WARNING! Multiple transactions are not supported in this mode\n");
-
 	/*
 	 * we do all of this in one transaction to enable the backend's
 	 * data-loading optimizations
@@ -5205,15 +5202,28 @@ initGenerateDataClientSideTextFrmt(PGconn *con)
 	/* truncate away any old data */
 	initTruncateTables(con);
 
-	/*
-	 * fill branches, tellers, accounts in that order in case foreign keys
-	 * already exist
-	 */
-	initPopulateTableCopyText(con, "pgbench_branches", nbranches, initBranch);
-	initPopulateTableCopyText(con, "pgbench_tellers", ntellers, initTeller);
-	initPopulateTableCopyText(con, "pgbench_accounts", naccounts, initAccount);
+	if (multi_xact)
+		executeStatement(con, "commit");
+
+	for (int i = 0; i < scale; i++)
+	{
+		if (multi_xact)
+			executeStatement(con, "begin");
+
+		/*
+		 * fill branches, tellers, accounts in that order in case foreign keys
+		 * already exist
+		 */
+		initPopulateTableCopyText(con, "pgbench_branches", i, nbranches, initBranch);
+		initPopulateTableCopyText(con, "pgbench_tellers", i, ntellers, initTeller);
+		initPopulateTableCopyText(con, "pgbench_accounts", i, naccounts, initAccount);
 
-	executeStatement(con, "commit");
+		if (multi_xact)
+			executeStatement(con, "commit");
+	}
+
+	if (!multi_xact)
+		executeStatement(con, "commit");
 }
 
 
@@ -5426,9 +5436,9 @@ initPopulateTableCopyBinary(PGconn *con, char *table, char *columns,
 
 	/* Use COPY with FREEZE on v14 and later for all ordinary tables */
 	if ((PQserverVersion(con) >= 140000) &&
-		get_table_relkind(con, table) == RELKIND_RELATION)
-		if (!multi_xact)
-			copy_statement_fmt = "copy %s (%s) from stdin with (format binary, freeze on)";
+		get_table_relkind(con, table) == RELKIND_RELATION &&
+		!multi_xact)
+		copy_statement_fmt = "copy %s (%s) from stdin with (format binary, freeze on)";
 
 	n = pg_snprintf(copy_statement, sizeof(copy_statement), copy_statement_fmt, table, columns);
 	if (n >= sizeof(copy_statement))
diff --git a/src/bin/pgbench/t/001_pgbench_with_server.pl b/src/bin/pgbench/t/001_pgbench_with_server.pl
index acb1e31d3e8..46569b0eb37 100644
--- a/src/bin/pgbench/t/001_pgbench_with_server.pl
+++ b/src/bin/pgbench/t/001_pgbench_with_server.pl
@@ -189,7 +189,7 @@ $node->pgbench(
 check_data_state($node, 'server-side (unnest)');
 
 
-# Test server-side generation with COPY TEXT
+# Test client-side generation with COPY TEXT
 $node->pgbench(
 	'--initialize --init-steps=dtg',
 	0,
@@ -200,45 +200,48 @@ $node->pgbench(
 		qr{generating data \(client-side as single transaction},
 		qr{done in \d+\.\d\d s }
 	],
-	'pgbench --init-steps client-side TEXT');
+	'pgbench --init-steps client-side TEXT (single XACT #1)');
 
-# Check data state, after server-side data generation.
+# Check data state, after client-side data generation.
 check_data_state($node, 'client-side (text)');
 
 $node->pgbench(
-	'--initialize --init-steps=dtMg',
+	'--initialize --init-steps=dtSg',
 	0,
 	[qr{^$}],
 	[
 		qr{dropping old tables},
 		qr{creating tables},
-		qr{generating data \(client-side as multiple transactions},
+		qr{generating data \(client-side as single transaction},
+		qr{\d of \d+ tuples \(\d%\) of pgbench_branches done},
+		qr{\d of \d+ tuples \(\d%\) of pgbench_tellers done},
+		qr{\d of \d+ tuples \(\d%\) of pgbench_accounts done},
 		qr{done in \d+\.\d\d s }
 	],
-	'pgbench --init-steps client-side TEXT');
+	'pgbench --init-steps client-side TEXT (single XACT #2)');
 
-# Check data state, after server-side data generation.
+# Check data state, after client-side data generation.
 check_data_state($node, 'client-side (text)');
 
-
-# Test server-side generation with COPY BINARY
 $node->pgbench(
-	'--initialize --init-steps=dtc',
+	'--initialize --init-steps=dtMg',
 	0,
 	[qr{^$}],
 	[
 		qr{dropping old tables},
 		qr{creating tables},
-		qr{generating data \(client-side as single transaction},
+		qr{generating data \(client-side as multiple transactions},
 		qr{done in \d+\.\d\d s }
 	],
-	'pgbench --init-steps client-side BINARY');
+	'pgbench --init-steps client-side TEXT (multiple XACTs)');
+
+# Check data state, after client-side data generation.
+check_data_state($node, 'client-side (text)');
 
-# Check data state, after server-side data generation.
-check_data_state($node, 'client-side (binary)');
 
+# Test client-side generation with COPY BINARY
 $node->pgbench(
-	'--initialize --init-steps=dtSc',
+	'--initialize --init-steps=dtc',
 	0,
 	[qr{^$}],
 	[
@@ -247,24 +250,24 @@ $node->pgbench(
 		qr{generating data \(client-side as single transaction},
 		qr{done in \d+\.\d\d s }
 	],
-	'pgbench --init-steps client-side BINARY');
+	'pgbench --init-steps client-side BINARY (single XACT #1)');
 
-# Check data state, after server-side data generation.
+# Check data state, after client-side data generation.
 check_data_state($node, 'client-side (binary)');
 
 $node->pgbench(
-	'--initialize --init-steps=dtMc',
+	'--initialize --init-steps=dtSc',
 	0,
 	[qr{^$}],
 	[
 		qr{dropping old tables},
 		qr{creating tables},
-		qr{generating data \(client-side as multiple transactions},
+		qr{generating data \(client-side as single transaction},
 		qr{done in \d+\.\d\d s }
 	],
-	'pgbench --init-steps client-side BINARY');
+	'pgbench --init-steps client-side BINARY (single XACT #2)');
 
-# Check data state, after server-side data generation.
+# Check data state, after client-side data generation.
 check_data_state($node, 'client-side (binary)');
 
 $node->pgbench(
@@ -279,7 +282,7 @@ $node->pgbench(
 	],
 	'pgbench --init-steps client-side BINARY');
 
-# Check data state, after server-side data generation.
+# Check data state, after client-side data generation.
 check_data_state($node, 'client-side (binary)');
 
 
-- 
2.43.0

